
#include "libcheetah.h"
#include <zlib.h>

extern long long int T;
int main(int argc, char ** argv){
  unsigned int addr, bytes;
  gzFile fd;
  unsigned long long int count=0;

  argc--;
  argv = &argv[1];


  cheetah_init(argc, argv);
  cheetah_config(stdout);
  fd = gzopen("/tmp/atrace.gz", "rb");


  do{
    bytes = gzread(fd, &addr, 4);
    cheetah_access(addr);
    count++;
    if((count % 1000000) == 0 ){
      gzrewind(fd);
    }

  }while(bytes == 4 && (long long )count < T);

  cheetah_stats(stdout, 0);
  gzclose(fd);
  return 0;
}

/* These are the golden numbers for 5000000
                1               2
No. of sets
128             0.059526        0.022016
256             0.037187        0.016823
512             0.031730        0.015634
1024            0.019046        0.014074
2048            0.015528        0.012961
4096            0.013911        0.012274
8192            0.013149        0.011809
16384           0.012464        0.011670


Full trace has: 2657892973 addrs which is greater than 1<<31
                Associativity
                1               2
No. of sets
128             0.128996        0.088876
256             0.101380        0.078135
*/
